#include "Mover.h"
#include "Hit.h"
#include "..\LibGame\Input.h"
#include <assert.h>




//==============================================================
// Vbg̃Tu[`

// ʏ̃Vbg
void CMover::Shot() {

	// ア
	if (Valid.Berserk && Berserk.State!=BS_NORMAL) return;
	
	// F̐؂ւ
	if (Valid.ChangeColor) {
		New(ChangeColor.Shot[Color-1]);
	}

	// A[
	if (Valid.Arm) {
		if (Arm.NumStock<=0) return;
		Arm.NumStock--;
		CMover* model=Weapon.Shot;
		CObject3D* obj3d=model->Obj3D;
		model->Obj3D=Arm.Stock[Arm.NumStock];
		New(model);
		model->Obj3D=obj3d;
	} else

	// Vbg̋
	if (Valid.RFShot) {
		CMoverGroup* mg=GetGroup(MYSHIP_GROUP);
		CMover *mover;
		CHit hit=*RFShot.Hit;
		hit.SetPos(X, Y);
		if (mover=mg->FirstHit(&hit)) {
			do {
				if (mover!=this) {
					switch (RFShot.Mode) {
						case 0:
							New(RFShot.Shot);
							return;
						case 1:
							CMover model=*RFShot.Shot;
							model.Angle=
								atan2(X-mover->X, mover->Y-Y)/D3DX_PI/2+0.25f;
							New(&model);
							return;
					}
				}
			} while (mover=mg->NextHit(&hit));
			New(Weapon.Shot);
		}
	} else

	// RɓƏ
	if (Valid.MovableSightS && MovableSightS.SightMover) {
		CMover* sight=MovableSightS.SightMover;
		CMover model=*Weapon.Shot;
		model.Valid.Target=true;
		model.Target.Type=TG_MOVER;
		model.Target.Mover=sight;
		New(&model);
	} else

	// 
	if (Valid.Docking && Docking.Docked) {
		New(Docking.Shot);
	} else

	// ACeɂ鋭
	if (Valid.SAItem && SAItem.EffectMover) {
		New(SAItem.ShotModel);
	} else

	// ʏ
	{
		New(Weapon.Shot);
		if (Valid.Captee && Captee.Doubled) {
			CMover* mover=New(Weapon.Shot);
			mover->X+=10;
		}
	}
}


// ߌ
void CMover::BigShot(int power) {
	New(Weapon.BigShot);
}


// őp[̗ߌ
void CMover::MaxShot() {
	New(Weapon.MaxShot);
}




//==============================================================
// {̃Vbg
void CMover::BasicShot(
	bool button,       // ̃{^̏
	bool& prev_button  // Õ{^̏
) {
	// Vbg̔ˁF
	// O{^Ă炸C񉟂ĂƂC
	// Vbg𔭎˂B
	// ˂̏ڍׂȏShot֐ōŝƂB
	if (!prev_button && button) Shot();
	
	// ̃{^̏Ԃۑ
	prev_button=button;
}


//==============================================================
// A
void CMover::AutoShot(
	bool button  // {^̏ԁiꂽƂtruej
) {
	// Vbg̔ˁF
	// {^ĂVbg𔭎˂B
	// ˂̏ڍׂȏShot֐ōŝƂB
	if (button) Shot();
}


//==============================================================
// ߌ
void CMover::PowerShot(
	bool button,    // {^̏ԁiꂽƂtruej
	int min_power,  // eoŏ̃p[
	int max_power,  // ő̃p[
	int& power      // ߃p[
) {
	// {^ĂꍇF
	// ߃p[𑝂₷B
	if (button && power<max_power) power++;
	
	// {^𗣂ĂꍇF
	// ߃p[>0ȂΒeC߃p[0ɖ߂B
	if (!button && power>0) {
		
		// őp[̂ƂF
		// ʂȒeB
		// ̓IȏMaxShot֐ōsƂB
		if (power==max_power) MaxShot(); else
		
		// ŏp[ȏCőp[̂ƂF
		// ߃p[ɉ̗ߌeB
		// ̓IȏBigShot֐ōsƂB
		if (min_power<=power) BigShot(power);
		
		// ߃p[0ɖ߂
		power=0;
	}
}


//==============================================================
// Z~I[gA
void CMover::SemiAutoShot(
	bool button,    // {^̏ԁiꂽƂtruej
	int min_power,  // ߃p[̍ŏl
	int max_power,  // ߃p[̍ől
	int max_gauge,  // A˃Q[W̍ől
	int& power,     // ߃p[
	int& gauge      // A˃Q[W
) {
	// {^Ăꍇ
	if (button) {
		
		// ߃p[s̏ꍇF
		// ʏ̒eB
		if (power<min_power) Shot();
	
		// ߃p[𑝂₵CA˃Q[Wőɂ
		if (power<max_power) power++;
		gauge=max_gauge;
	}
	
	// {^𗣂ĂꍇF
	else {
		
		// ߃p[\̏ꍇF
		// ߌeF
		// őp[̂Ƃ͓ʂȒeB
		if (min_power<=power) {
			if (power==max_power) MaxShot(); 
				else BigShot(power);
			gauge=0;
		}
		
		// A˃Q[W>0̏ꍇF
		// ʏ̒eCA˃Q[W-1B
		if (gauge>0) {
			Shot();
			gauge--;
		}

		// ߃p[0ɂ
		power=0;
	}
}


//==============================================================
// {^𗣂ė߂闭ߌ
void CMover::PowerShotReleased(
	bool button,    // {^̏ԁiꂽƂtruej
	int min_power,  // eoŏ̃p[
	int max_power,  // ő̃p[
	int& power      // ߃p[
) {
	// {^𗣂ĂꍇF
	// ߃p[𑝂₷B
	if (!button && power<max_power) power++;
	
	// {^ĂꍇF
	// ߃p[>0ȂΒeC߃p[0ɖ߂B
	if (button && power>0) {
		
		// őp[̂ƂF
		// ʂȒeB
		// ̓IȏMaxShot֐ōsƂB
		if (power==max_power) MaxShot(); else
		
		// ŏp[ȏCőp[̂ƂF
		// ߃p[ɉ̗ߌeB
		// ̓IȏBigShot֐ōsƂB
		if (min_power<=power) BigShot(power);
		
		// ߃p[0ɖ߂
		power=0;
	}
}


//==============================================================
// R}hVbg
void CMover::CommandShot(const CInputState* is) {
	int& index=Weapon.Cmd.HistIndex;
	int* hist=Weapon.Cmd.Hist;
	COMMAND_LIST* list=Weapon.Cmd.List;

	// ͂𗚗ɋL^
	hist[index]=
		(is->Up?CMD_UP:0)|
		(is->Down?CMD_DOWN:0)|
		(is->Left?CMD_LEFT:0)|
		(is->Right?CMD_RIGHT:0)|
		(is->Button[0]?CMD_BUTTON0:0)|
		(is->Button[1]?CMD_BUTTON1:0)|
		(is->Button[2]?CMD_BUTTON2:0)|
		(is->Button[3]?CMD_BUTTON3:0);

	// eR}h͂ꂽǂ𔻒肷
	int c, j, i;
	for (c=0; c<list->NumCommand; c++) {
		COMMAND& cmd=list->Command[c];
		
		// R}h̓͊mF
		for (i=0, j=cmd.Length-1; j>=0; j--) {
			for (; i<cmd.Limit; i++) {
				if (hist[(index-i+NUM_CMD_HIST)%NUM_CMD_HIST]==
					cmd.Input[j]) break;
			}
			if (i==cmd.Limit) break;
		}
		
		// R}h̓͂mFłF
		// R}hVbgCNAB
		if (j==-1) {
			CMover* mover=Group->GetManager()->GetGroup(WEAPON_GROUP)->New();
			if (mover) mover->Init(cmd.Model, this);
			for (i=0; i<NUM_CMD_HIST; i++) hist[i]=CMD_NONE;
		}
	}
	
	// L^ʒuXV
	index=(index+1)%NUM_CMD_HIST;
}


//==============================================================
// A˂ƃ[U[̋
void CMover::ShotAndLaser(
	bool button,    // {^̏ԁiꂽƂtruej
	int min_power,  // ߃p[̍ŏl
	int max_gauge,  // A˃Q[W̍ől
	int& power,     // ߃p[
	int& gauge      // A˃Q[W
) {
	// {^Ăꍇ
	if (button) {
		
		// ߃p[s̏ꍇF
		// ߃p[𑝂₵CA˃Q[WőɂāC
		// eB̓IȏShot֐ōsƂB
		if (power<min_power) {
			power++;
			gauge=max_gauge;
			Shot();
		}
	
		// ߃p[\̏ꍇF
		// A˃Q[W0ɂāC[U[B
		else {
			gauge=0;
			CMover* mover=Group->GetManager()->GetGroup(WEAPON_GROUP)->New();
			if (mover) mover->Init(Weapon.Laser, this);
		}
	}
	
	// {^𗣂ĂꍇF
	else {
		
		// A˃Q[W>0̏ꍇF
		// ʂ̒eCA˃Q[W-1B
		if (gauge>0) {
			Shot();
			gauge--;
		}

		// ߃p[0ɂ
		power=0;
	}
}


//==============================================================
// bNVbg
void CMover::LockShot(
	bool button,     // {^̏ԁiꂽƂtruej
	int min_power,   // ߃p[̍ŏl
	int max_gauge,   // A˃Q[W̍ől
	int& power,      // ߃p[
	int& gauge       // A˃Q[W
) {
	// {^Ăꍇ
	if (button) {
		
		// ߃p[s̏ꍇF
		// ߃p[𑝂₵CA˃Q[WőɂāC
		// eB̓IȏShot֐ōsƂB
		if (power<min_power) {
			power++;
			gauge=max_gauge;
			Shot();
		}
	
		// ߃p[\̏ꍇF
		// A˃Q[W0ɂāCbNVbgB
		else {
			gauge=0;
			
			// bNVbgF
			// GǔĂƂ͓G_B
			// iu@ɌĔԒevƓlj
			// GǔĂȂƂ͎@̐ʂɒeB
			// iuRȕɔԒevƓlj
			CMover* mover=Group->GetManager()->GetGroup(WEAPON_GROUP)->New();
			mover->Init(Weapon.Laser, this);
		}
	}
	
	// {^𗣂ĂꍇF
	else {
		
		// A˃Q[W>0̏ꍇF
		// ʂ̒eCA˃Q[W-1B
		if (gauge>0) {
			Shot();
			gauge--;
		}

		// ߃p[0ɂ
		power=0;

		// bNO
		ClearLockedEnemy();
	}
}




