#pragma once
#include <d3d9.h>


//==============================================================
// OtBbNX`@\ǗNX
class CGraphics {
protected:

	// Direct3DC^[tFCXCfoCXC_obt@
	LPDIRECT3D9 D3D;
	LPDIRECT3DDEVICE9 Device;

	// EBhEnh
	HWND HWnd;
	
	// ƍiEBhE[hCSʃ[hj
	int WinModeWidth, WinModeHeight;
	int FullModeWidth, FullModeHeight;
	
	// EBhEg̕ƍCEBhEX^C
	int FrameWidth, FrameHeight;
	DWORD WindowStyle;

	// tXN[[hCZobt@̎gp
	bool FullMode, ZBuffer;

	// foCX̕
	bool RestoreDevice();
	bool Restored;

public:

	// RXgN^CfXgN^
	CGraphics(HWND hwnd, bool zbuffer);
	~CGraphics();

	// V[`̊JnCI
	bool BeginScene() { return SUCCEEDED(Device->BeginScene()); }
	void EndScene() { Device->EndScene(); }

	// ʏCʃtbv
	void Clear(D3DCOLOR color=D3DCOLOR_XRGB(0,0,0));
	void Present();

	// foCX̕
	bool CheckRestored() {
		bool ret=Restored;
		Restored=false;
		return ret;
	}

	// ʂ̕ƍ
	int GetWidth() { return FullMode?FullModeWidth:WinModeWidth; }
	int GetHeight() { return FullMode?FullModeHeight:WinModeHeight; }

	// foCX̎擾
	LPDIRECT3DDEVICE9 GetDevice() { return Device; }

	// tXN[[hiݒCݒlCgOj
	void SetFullMode(bool full_mode);
	bool IsFullMode() { return FullMode; }

	// Cg̐ݒ
	void SetLight(
		int id, D3DLIGHTTYPE type, 
		float x, float y, float z,
		float range=1000
	);
};





